MODULE Beeldprogrammer_verschill_intensit;

FROM IO IMPORT RdChar, WrChar, WrStr, RdStr, WrLn, RdLn, RdCard, WrCard, RdInt, WrInt, RdReal, WrReal, WrFixReal, RdBool, WrBool, RdKey, KeyPressed;
FROM RealMath IMPORT sqrt, exp, sin, cos, tan, arcsin, arccos, arctan, power, round, pi;
FROM Lib IMPORT Delay; (* Wait n milliseconds *)
FROM Graph IMPORT Init, Line, Rectangle, Circle, Disc, Polygon, RawOutText, _clrBLACK, _clrBLUE, _clrGREEN, _clrCYAN, _clrRED, _clrMAGENTA;
FROM Graph IMPORT _clrBROWN, _clrWHITE, _clrGRAY, _clrLIGHTBLUE, _clrLIGHTGREEN, _clrLIGHTCYAN, _clrLIGHTRED, _clrLIGHTMAGENTA, _clrLIGHTYELLOW, _clrBRIGHTWHITE;
FROM StandardLib IMPORT Distance, AngleWithXAx, RadiansToDegrees;
FROM Mouse IMPORT GetMuisX,GetMuisY,InitMuis,UpdateMuis,Clicked,Moved;
IMPORT FIO; (* Use this library for file manipulation *)
              (* see FIO.def under your XDS-directory => Def => Ts *)


TYPE     LED = RECORD  toestand: INTEGER; (* 0,1,2,3,4: uit & 4 intensiteiten*)
         END;
         PORT=(PORTA,PORTB,PORTC,PORTD);


CONST

(* AFMETINGEN:
pixels = mm * 2
100 pix = 29 mm
*)
      SCREEN_SIZE_X          = 600;  (* veelvoud van 100 *)		
      SCREEN_SIZE_Y          = 600;  (* veelvoud van 100 *)
      STRAAL_LED             = 3;    (* 2 te klei, 3 te groot *)
      STRAAL_BINNENCIRKEL    = 30;
      AFSTAND_LEDS	     = 10;
(* ANDERE CONSTANTES *)
      TOTAAL_AANTAL_ADRESSEN = 96+3*80;
      VISUALIZE_STEPS        = FALSE;
      BUTTON_SIZE_X          = 130;
      BUTTON_SIZE_Y          = 25;
      INTENS_KNOPPEN_X       = 380;
      INTENS_KNOPPEN_Y       = 5;
      AFST_INTENS_KNOPPEN    = 30;
      GROOTTE_INTENS_KNOPPEN = 25;
      AANTAL_HOEKEN_MAX      = 500;  (* MAX 500, anders kan em niet zo veel zo grote matrixen aan:
                                        dan komt en PROCEDURE UseFiles(); niet eens binnen opt einde
					omdat em ziet dat daar te veel grote variabelen gebruikt worden (VAR ...)
					hij geef dan wel geen foutmelding, maar beindigt wel t programma *)
                                     (* 700 laten, want als te klein kiezen: ook problemen ! *)
VAR
    myFile: FIO.File;
    poorten_array: ARRAY[1..AANTAL_HOEKEN_MAX*24] OF INTEGER;
    eerste_adres,register_adres,bank,aantal_gebruikte_adressen,nullen: INTEGER;
    poorten_matriks,kopie: ARRAY[1..AANTAL_HOEKEN_MAX*4],[1..8] OF INTEGER;
    n,freq_motor,delay_aan, delay_uit:INTEGER;
    intens0,intens1,intens2,intens3,intens4,end,create_bitmap,bekijken,nul,een,twee,drie,vier: BOOLEAN;
    led : ARRAY[1..AANTAL_HOEKEN_MAX],[1..24] OF LED;
    led_copy: ARRAY[1..AANTAL_HOEKEN_MAX],[1..24] OF LED;
    mp_x, mp_y, rho : INTEGER;
    screen_size_x, screen_size_y, straal_led, straal_binnencirkel,afstand_leds : INTEGER;
    mouse_x,mouse_y : INTEGER;
    hoek_stap: REAL;
    i,j,aantal_hoeken,schaal:INTEGER;

(********************************************* PROCEDURES *********************************************)


PROCEDURE Kleur(intensity:INTEGER):CARDINAL;

BEGIN

IF intensity=1 THEN
   RETURN _clrWHITE;
ELSIF intensity=2 THEN
   RETURN _clrGRAY;
ELSIF intensity=3 THEN
   RETURN _clrLIGHTYELLOW;
ELSIF intensity=4 THEN
   RETURN _clrRED;
END;

END Kleur;

(******************************************************************************************************)

PROCEDURE BeeldMatrix();

VAR poort,i,j,k,k_max:INTEGER;


BEGIN

WrLn();
WrLn();



(* WIJZERZIN --> TGWZ (per 24) *)
FOR j:=1 TO aantal_hoeken DO
  FOR i:=1 TO 24 DO
    led_copy[j,i].toestand:= led[j,i].toestand;
  END;
END;
FOR j:=1 TO aantal_hoeken DO
  FOR i:=1 TO 24 DO
   led[j,i].toestand:= led_copy[aantal_hoeken+1-j,i].toestand;
  END;
END;




(* VISUALIZE led[j,i].toestand in TWZ *)
IF VISUALIZE_STEPS THEN
WrStr('led.toestand-matrix tegenwijzerzin');
WrLn();
WrLn();
FOR j:=1 TO aantal_hoeken DO
 FOR i:=1 TO 24 DO
  WrInt(led[j,i].toestand, 2);
 END;
 WrLn();
END;
WrLn();
WrLn();
END;



(* aantal_hoeken x 24 --> rijmatrix *)
k:=0;
FOR j:=1 TO aantal_hoeken DO
 FOR i:=1 TO 24 DO
  k:=k+1;
  poorten_array[k]:= led[j,i].toestand;
 END;
END;
k_max:=k;

(* VISUALIZE poorten_array *)
IF VISUALIZE_STEPS THEN
WrStr('aantal_hoeken x 24 --> rijmatrix');
WrLn();
WrLn();
FOR j:=1 TO aantal_hoeken*24 DO
  WrInt(poorten_array[j], 2);
END;
WrLn();
WrLn();
END;



(* rijmatrix --> poorten_matriks: aantal_hoeken*4 x 8:   8 - 4 - 4 - 8 ... *)
j:=0;
REPEAT
 k:=0;
 i:=0;
 REPEAT
  k:=k+1;
  IF k=9 THEN
   i:=0;
  ELSIF k=13 THEN
   i:=0;
  ELSIF k=17 THEN
   i:=0;
  END;

  IF i=0 THEN
   j:=j+1;
  END;

  i:=i+1;
  poorten_matriks[j,i]:= poorten_array[k];

 UNTIL k=24;

 FOR k:=1 TO k_max-24 DO
  poorten_array[k]:=poorten_array[k+24]
 END;
 k_max:=k_max-24;

UNTIL k_max=0;

(* VISUALIZE poorten_matriks *)
IF VISUALIZE_STEPS THEN
WrStr('rijmatrix --> poorten_matriks: aantal_hoeken*4 x 8:   8 - 4 - 4 - 8 ...');
WrLn();
WrLn();
FOR j:=1 TO aantal_hoeken*4 DO
 FOR i:=1 TO 8 DO
  WrInt(poorten_matriks[j,i], 2);
 END;
 WrLn();
END;
WrLn();
WrLn();
END;


(* per 8 bits inverteren *)
kopie:=poorten_matriks;
FOR j:=1 TO aantal_hoeken*4 DO
 FOR i:=1 TO 8 DO
  poorten_matriks[j,i]:=kopie[j,9-i]
 END;
END;

(* VISUALIZE poorten_matriks na per 8 bits inverteren *)
IF VISUALIZE_STEPS THEN
WrStr('per 8 bits inverteren');
WrLn();
WrLn();
FOR j:=1 TO aantal_hoeken*4 DO
 FOR i:=1 TO 8 DO
  WrInt(poorten_matriks[j,i], 2);
 END;
 WrLn();
END;
WrLn();
WrLn();
END;



(* B0 -> B4 , B0:=0 *)
FOR j:=1 TO aantal_hoeken*4 DO
  IF (j+2) MOD 4 = 0 THEN
  poorten_matriks[j,4]:=poorten_matriks[j,8];
  poorten_matriks[j,8]:=0;
  END;
END;	

END BeeldMatrix;


(******************************************************************************************************)

PROCEDURE MaakText();

VAR i,j,k,l,poort:INTEGER;

BEGIN

myFile := FIO.Create("IM.txt"); (* create file in same directory of module *)
(* myFile := FIO.Create("C:/My Documents/test.txt"); (* create file in a specific directory *) *)

 FIO.WrStr(myFile, "__MOVLW_D'");
 FIO.WrInt(myFile,aantal_hoeken, 0);
 FIO.WrStr(myFile, "'__;# positions");
 FIO.WrLn(myFile);
 FIO.WrStr(myFile, "__MOVWF_HOEKTELLER");
 FIO.WrLn(myFile);
 FIO.WrStr(myFile, "BEGIN");
 FIO.WrLn(myFile);
 FIO.WrStr(myFile, "__MOVLW_D'2'");
 FIO.WrLn(myFile);
 FIO.WrStr(myFile, "__MOVWF_HOEKVERANDERD");
 FIO.WrLn(myFile);


FOR j:=1 TO aantal_hoeken DO


 (* hoek x *)
 FIO.WrStr(myFile, "hoek");
 FIO.WrInt(myFile,aantal_hoeken-j+1, 0);
 FIO.WrLn(myFile);

 IF j=1 THEN
  FIO.WrStr(myFile, "__MOVF_HOEKVERANDERD,0");
  FIO.WrLn(myFile);
  FIO.WrStr(myFile, "__MOVWF_TEST");
  FIO.WrLn(myFile);
  FIO.WrStr(myFile, "__DECFSZ_TEST,1");
  FIO.WrLn(myFile);
  FIO.WrStr(myFile, "__GOTO_hoek");
  FIO.WrInt(myFile,aantal_hoeken, 0);
  FIO.WrLn(myFile);
 END;
		
 FIO.WrStr(myFile, "__MOVF_HOEKTELLER,0");
 FIO.WrLn(myFile);
 FIO.WrStr(myFile, "__SUBLW_D'");
 FIO.WrInt(myFile,aantal_hoeken-j+2,0);
 FIO.WrStr(myFile, "'");
 FIO.WrLn(myFile);
 FIO.WrStr(myFile, "__MOVWF_TEST");
 FIO.WrLn(myFile);
 FIO.WrStr(myFile, "__DECFSZ_TEST,1");
 FIO.WrLn(myFile);

 IF j=aantal_hoeken THEN
  FIO.WrStr(myFile, "__GOTO_BEGIN");
  FIO.WrLn(myFile);
 ELSE
  FIO.WrStr(myFile, "__GOTO_hoek");
  FIO.WrInt(myFile,aantal_hoeken-j,0);
  FIO.WrLn(myFile);
 END;

(* KIJKEN WELKE INTENSITEITEN ER ZIJN *)
   nul:=FALSE;
   een:=FALSE;
   twee:=FALSE;
   drie:=FALSE;
   vier:=FALSE;
 (* ALLES INTENSIT 0 ?*)
 nullen:=0;
 FOR i:=1 TO 8  DO
  nullen:=nullen+poorten_matriks[j*4-3,i];
  nullen:=nullen+poorten_matriks[j*4-2,i];
  nullen:=nullen+poorten_matriks[j*4-1,i];
  nullen:=nullen+poorten_matriks[j*4,i];
 END;
 IF nullen=0 THEN
  nul:=TRUE;
 ELSE
  nul:=FALSE;
 END;

 IF nul=TRUE THEN
  FIO.WrStr(myFile, "__GOTO_BEGIN");
  FIO.WrLn(myFile);
 END;

 (* INTENSIT 1 ERBIJ ? *)
 FOR i:=1 TO 8  DO
  IF poorten_matriks[j*4-3,i]=1 THEN
   een:=TRUE;
  ELSIF poorten_matriks[j*4-2,i]=1 THEN
   een:=TRUE;
  ELSIF poorten_matriks[j*4-1,i]=1 THEN
   een:=TRUE;
  ELSIF poorten_matriks[j*4,i]=1 THEN
   een:=TRUE;
  END;
 END;

 (* INTENSIT 2 ERBIJ ? *)
 FOR i:=1 TO 8  DO
  IF poorten_matriks[j*4-3,i]=2 THEN
   twee:=TRUE;
  ELSIF poorten_matriks[j*4-2,i]=2 THEN
   twee:=TRUE;
  ELSIF poorten_matriks[j*4-1,i]=2 THEN
   twee:=TRUE;
  ELSIF poorten_matriks[j*4,i]=2 THEN
   twee:=TRUE;
  END;
 END;

 (* INTENSIT 3 ERBIJ ? *)
 FOR i:=1 TO 8  DO
  IF poorten_matriks[j*4-3,i]=3 THEN
   drie:=TRUE;
  ELSIF poorten_matriks[j*4-2,i]=3 THEN
   drie:=TRUE;
  ELSIF poorten_matriks[j*4-1,i]=3 THEN
   drie:=TRUE;
  ELSIF poorten_matriks[j*4,i]=3 THEN
   drie:=TRUE;
  END;
 END;

 (* INTENSIT 4 ERBIJ ? *)
 FOR i:=1 TO 8  DO
  IF poorten_matriks[j*4-3,i]=4 THEN
   vier:=TRUE;
  ELSIF poorten_matriks[j*4-2,i]=4 THEN
   vier:=TRUE;
  ELSIF poorten_matriks[j*4-1,i]=4 THEN
   vier:=TRUE;
  ELSIF poorten_matriks[j*4,i]=4 THEN
   vier:=TRUE;
  END;
 END;

 (* GOTO-UPDATE *)
 IF nul=TRUE THEN

 ELSE
   FIO.WrStr(myFile, "__GOTO_UPDATE");
   FIO.WrInt(myFile,aantal_hoeken-j+1, 0);
   FIO.WrLn(myFile);

  (* UPDATE *)

  FIO.WrStr(myFile, "UPDATE");
  FIO.WrInt(myFile,aantal_hoeken-j+1, 0);
  FIO.WrLn(myFile);
  (* BANK 0 *)
  FIO.WrStr(myFile, "__BCF_STATUS,RP0");
  FIO.WrLn(myFile);
  FIO.WrStr(myFile, "__BCF_STATUS,RP1");
  FIO.WrLn(myFile);
  (* POORT D *)
  FIO.WrStr(myFile, "__MOVLW_B'");
  FOR i:=1 TO 8  DO
   IF (poorten_matriks[j*4-3,i]=4) OR (poorten_matriks[j*4-3,i]=3) OR (poorten_matriks[j*4-3,i]=2) OR (poorten_matriks[j*4-3,i]=1) THEN
     FIO.WrStr(myFile, "1");
   ELSE
     FIO.WrStr(myFile, "0");
   END;
  END;
  FIO.WrStr(myFile, "'");
  FIO.WrLn(myFile);
  FIO.WrStr(myFile, "__MOVWF_");
  FIO.WrStr(myFile, "PORTD");
  FIO.WrLn(myFile);
  (* POORT B *)
  FIO.WrStr(myFile, "__MOVLW_B'");
  FOR i:=1 TO 8  DO
   IF (poorten_matriks[j*4-2,i]=4) OR (poorten_matriks[j*4-2,i]=3) OR (poorten_matriks[j*4-2,i]=2) OR (poorten_matriks[j*4-2,i]=1) THEN
     FIO.WrStr(myFile, "1");
   ELSE
     FIO.WrStr(myFile, "0");
   END;
  END;
  FIO.WrStr(myFile, "'");
  FIO.WrLn(myFile);
  FIO.WrStr(myFile, "__MOVWF_");
  FIO.WrStr(myFile, "PORTB");
  FIO.WrLn(myFile);
  (* POORT A *)
  FIO.WrStr(myFile, "__MOVLW_B'");
  FOR i:=1 TO 8  DO
   IF (poorten_matriks[j*4-1,i]=4) OR (poorten_matriks[j*4-1,i]=3) OR (poorten_matriks[j*4-1,i]=2) OR (poorten_matriks[j*4-1,i]=1) THEN
     FIO.WrStr(myFile, "1");
   ELSE
     FIO.WrStr(myFile, "0");
   END;
  END;
  FIO.WrStr(myFile, "'");
  FIO.WrLn(myFile);
  FIO.WrStr(myFile, "__MOVWF_");
  FIO.WrStr(myFile, "PORTA");
  FIO.WrLn(myFile);
  (* POORT C *)
  FIO.WrStr(myFile, "__MOVLW_B'");
  FOR i:=1 TO 8  DO
   IF (poorten_matriks[j*4,i]=4) OR (poorten_matriks[j*4,i]=3) OR (poorten_matriks[j*4,i]=2) OR (poorten_matriks[j*4,i]=1) THEN
     FIO.WrStr(myFile, "1");
   ELSE
     FIO.WrStr(myFile, "0");
   END;
  END;
  FIO.WrStr(myFile, "'");
  FIO.WrLn(myFile);
  FIO.WrStr(myFile, "__MOVWF_");
  FIO.WrStr(myFile, "PORTC");
  FIO.WrLn(myFile);

 (* EERSTE INTENSITEIT UITDOEN *)
 IF een=TRUE THEN
  (* POORT D *)
  FIO.WrStr(myFile, "__MOVLW_B'");
  FOR i:=1 TO 8  DO
   IF (poorten_matriks[j*4-3,i]=1) OR (poorten_matriks[j*4-3,i]=0) THEN
     FIO.WrStr(myFile, "0");
   ELSE
     FIO.WrStr(myFile, "1");
   END;
  END;
  FIO.WrStr(myFile, "'");
  FIO.WrLn(myFile);
  FIO.WrStr(myFile, "__MOVWF_");
  FIO.WrStr(myFile, "PORTD");
  FIO.WrLn(myFile);
  (* POORT B *)
  FIO.WrStr(myFile, "__MOVLW_B'");
  FOR i:=1 TO 8  DO
   IF (poorten_matriks[j*4-2,i]=1) OR (poorten_matriks[j*4-2,i]=0) THEN
     FIO.WrStr(myFile, "0");
   ELSE
     FIO.WrStr(myFile, "1");
   END;
  END;
  FIO.WrStr(myFile, "'");
  FIO.WrLn(myFile);
  FIO.WrStr(myFile, "__MOVWF_");
  FIO.WrStr(myFile, "PORTB");
  FIO.WrLn(myFile);
  (* POORT A *)
  FIO.WrStr(myFile, "__MOVLW_B'");
  FOR i:=1 TO 8  DO
   IF (poorten_matriks[j*4-1,i]=1) OR (poorten_matriks[j*4-1,i]=0) THEN
     FIO.WrStr(myFile, "0");
   ELSE
     FIO.WrStr(myFile, "1");
   END;
  END;
  FIO.WrStr(myFile, "'");
  FIO.WrLn(myFile);
  FIO.WrStr(myFile, "__MOVWF_");
  FIO.WrStr(myFile, "PORTA");
  FIO.WrLn(myFile);
  (* POORT C *)
  FIO.WrStr(myFile, "__MOVLW_B'");
  FOR i:=1 TO 8  DO
   IF (poorten_matriks[j*4,i]=1) OR (poorten_matriks[j*4,i]=0) THEN
     FIO.WrStr(myFile, "0");
   ELSE
     FIO.WrStr(myFile, "1");
   END;
  END;
  FIO.WrStr(myFile, "'");
  FIO.WrLn(myFile);
  FIO.WrStr(myFile, "__MOVWF_");
  FIO.WrStr(myFile, "PORTC");
  FIO.WrLn(myFile);
 END;

  (* DELAY_2 *)
   FIO.WrStr(myFile, "__CALL_DELAY2");
   FIO.WrLn(myFile);



  (* TWEEDE INTENSITEIT UITDOEN *)
 IF twee=TRUE THEN
  (* POORT D *)
  FIO.WrStr(myFile, "__MOVLW_B'");
  FOR i:=1 TO 8  DO
   IF (poorten_matriks[j*4-3,i]=0) OR (poorten_matriks[j*4-3,i]=1) OR (poorten_matriks[j*4-3,i]=2) THEN
     FIO.WrStr(myFile, "0");
   ELSE
     FIO.WrStr(myFile, "1");
   END;
  END;
  FIO.WrStr(myFile, "'");
  FIO.WrLn(myFile);
  FIO.WrStr(myFile, "__MOVWF_");
  FIO.WrStr(myFile, "PORTD");
  FIO.WrLn(myFile);
  (* POORT B *)
  FIO.WrStr(myFile, "__MOVLW_B'");
  FOR i:=1 TO 8  DO
   IF (poorten_matriks[j*4-2,i]=0) OR (poorten_matriks[j*4-2,i]=1) OR (poorten_matriks[j*4-2,i]=2) THEN
     FIO.WrStr(myFile, "0");
   ELSE
     FIO.WrStr(myFile, "1");
   END;
  END;
  FIO.WrStr(myFile, "'");
  FIO.WrLn(myFile);
  FIO.WrStr(myFile, "__MOVWF_");
  FIO.WrStr(myFile, "PORTB");
  FIO.WrLn(myFile);
  (* POORT A *)
  FIO.WrStr(myFile, "__MOVLW_B'");
  FOR i:=1 TO 8  DO
   IF (poorten_matriks[j*4-1,i]=0) OR (poorten_matriks[j*4-1,i]=1) OR (poorten_matriks[j*4-1,i]=2) THEN
     FIO.WrStr(myFile, "0");
   ELSE
     FIO.WrStr(myFile, "1");
   END;
  END;
  FIO.WrStr(myFile, "'");
  FIO.WrLn(myFile);
  FIO.WrStr(myFile, "__MOVWF_");
  FIO.WrStr(myFile, "PORTA");
  FIO.WrLn(myFile);
  (* POORT C *)
  FIO.WrStr(myFile, "__MOVLW_B'");
  FOR i:=1 TO 8  DO
   IF (poorten_matriks[j*4,i]=0) OR (poorten_matriks[j*4,i]=1) OR (poorten_matriks[j*4,i]=2) THEN
     FIO.WrStr(myFile, "0");
   ELSE
     FIO.WrStr(myFile, "1");
   END;
  END;
  FIO.WrStr(myFile, "'");
  FIO.WrLn(myFile);
  FIO.WrStr(myFile, "__MOVWF_");
  FIO.WrStr(myFile, "PORTC");
  FIO.WrLn(myFile);
 END;

  (* DELAY_3*)
   FIO.WrStr(myFile, "__CALL_DELAY3");
   FIO.WrLn(myFile);


  (* DERDE INTENSITEIT UITDOEN *)
 IF drie=TRUE THEN
  (* POORT D *)
  FIO.WrStr(myFile, "__MOVLW_B'");
  FOR i:=1 TO 8  DO
   IF (poorten_matriks[j*4-3,i]=3) OR (poorten_matriks[j*4-3,i]=2) OR (poorten_matriks[j*4-3,i]=1) OR (poorten_matriks[j*4-3,i]=0) THEN
     FIO.WrStr(myFile, "0");
   ELSE
     FIO.WrStr(myFile, "1");
   END;
  END;
  FIO.WrStr(myFile, "'");
  FIO.WrLn(myFile);
  FIO.WrStr(myFile, "__MOVWF_");
  FIO.WrStr(myFile, "PORTD");
  FIO.WrLn(myFile);
  (* POORT B *)
  FIO.WrStr(myFile, "__MOVLW_B'");
  FOR i:=1 TO 8  DO
   IF (poorten_matriks[j*4-2,i]=3) OR (poorten_matriks[j*4-2,i]=2) OR (poorten_matriks[j*4-2,i]=1) OR (poorten_matriks[j*4-2,i]=0) THEN
     FIO.WrStr(myFile, "0");
   ELSE
     FIO.WrStr(myFile, "1");
   END;
  END;
  FIO.WrStr(myFile, "'");
  FIO.WrLn(myFile);
  FIO.WrStr(myFile, "__MOVWF_");
  FIO.WrStr(myFile, "PORTB");
  FIO.WrLn(myFile);
  (* POORT A *)
  FIO.WrStr(myFile, "__MOVLW_B'");
  FOR i:=1 TO 8  DO
   IF (poorten_matriks[j*4-1,i]=3) OR (poorten_matriks[j*4-1,i]=2) OR (poorten_matriks[j*4-1,i]=1) OR (poorten_matriks[j*4-1,i]=0) THEN
     FIO.WrStr(myFile, "0");
   ELSE
     FIO.WrStr(myFile, "1");
   END;
  END;
  FIO.WrStr(myFile, "'");
  FIO.WrLn(myFile);
  FIO.WrStr(myFile, "__MOVWF_");
  FIO.WrStr(myFile, "PORTA");
  FIO.WrLn(myFile);
  (* POORT C *)
  FIO.WrStr(myFile, "__MOVLW_B'");
  FOR i:=1 TO 8  DO
   IF (poorten_matriks[j*4,i]=3) OR (poorten_matriks[j*4,i]=2) OR (poorten_matriks[j*4,i]=1) OR (poorten_matriks[j*4,i]=0) THEN
     FIO.WrStr(myFile, "0");
   ELSE
     FIO.WrStr(myFile, "1");
   END;
  END;
  FIO.WrStr(myFile, "'");
  FIO.WrLn(myFile);
  FIO.WrStr(myFile, "__MOVWF_");
  FIO.WrStr(myFile, "PORTC");
  FIO.WrLn(myFile);
 END;

  (* DELAY_4*)
   FIO.WrStr(myFile, "__CALL_DELAY4");
   FIO.WrLn(myFile);


  (* VIERDE INTENSITEIT UITDOEN *)
 IF vier=TRUE THEN
  FIO.WrStr(myFile, "__CALL_LEDSUIT");
  FIO.WrLn(myFile);
 END;
  FIO.WrStr(myFile, "__GOTO_BEGIN");
  FIO.WrLn(myFile);
 END;
END;

WrLn();
WrLn();

FIO.Close(myFile); (* close file after use *)

END MaakText;


(********************************************************************************************************)
(************************** HOOFDPROGRAMMA **************************************************************)
(********************************************************************************************************)


BEGIN

WrLn;
WrLn;
WrLn;




(* KEUZE OPTIES *)
WrStr('********************************************');
WrLn();
WrStr('*  24 LEDS BITMAP TO PIC-MEMORY CONVERTER  *');
WrLn();
WrStr('********************************************');
WrLn();
WrLn();
WrStr('O P T I O N S');
WrLn();
WrStr('-------------');
WrLn();
WrLn();
WrStr('# LED positions: ');
aantal_hoeken:=RdInt();
WrLn();
WrStr('Zoom (0%: 15" screen, 70% = true size):  ');
schaal:=RdInt();
WrLn();
WrLn();
WrLn();
WrLn();





(* AFMETINGEN NA SCHALING *)

      screen_size_x         := SCREEN_SIZE_X + SCREEN_SIZE_X * schaal/100 ; (*veelvoud van 100*)		
      screen_size_y         := SCREEN_SIZE_Y + SCREEN_SIZE_Y * schaal/100 ;   (*veelvoud van 100*)
      straal_led            := STRAAL_LED + STRAAL_LED * schaal/100 ;
      straal_binnencirkel   := STRAAL_BINNENCIRKEL + STRAAL_BINNENCIRKEL * schaal/100 ;
      afstand_leds          := AFSTAND_LEDS + AFSTAND_LEDS * schaal/100 ;

(* INITIALISATIE VARIABELEN*)

      intens4:=TRUE;
      end:=FALSE;
      create_bitmap:=FALSE;
      bekijken:=FALSE;
      WrLn();

(* GRAPH AND MOUSE INIT*)


IF NOT InitMuis(1, 1 , screen_size_x+5, screen_size_y+31) THEN
WrStr("Sorry, mouse doesn't work");WrLn;
   RETURN;	
END;

(*
(*CIRKELS ROND ROTATIEPUNT*)
FOR i:=0 TO 23 DO
Circle(screen_size_x/2,screen_size_y/2,straal_binnencirkel+i*afstand_leds, _clrRED);
END;

(*LIJNEN ROND ROTATIEPUNT*)
hoek_stap:=2.*pi/VAL(REAL,aantal_hoeken);
FOR i:=0 TO aantal_hoeken DO
Line(screen_size_x/2,screen_size_y/2, VAL(INTEGER, VAL(REAL,(straal_binnencirkel+23*afstand_leds))*cos(hoek_stap* VAL(REAL,i)))+screen_size_x/2,VAL(INTEGER, VAL(REAL,(straal_binnencirkel+23*afstand_leds))*sin(hoek_stap* VAL(REAL,i)))+screen_size_y/2,_clrWHITE);
END;
*)

(* INIT TOESTAND LEDS *)

FOR i:=0 TO 23 DO
 FOR j:=0 TO aantal_hoeken-1 DO
  led[j+1,i+1].toestand := 0;
 END;
END;


(* TEKENEN INIT TOESTAND LEDS *)
hoek_stap:=2.*pi/VAL(REAL,aantal_hoeken);
FOR i:=0 TO 23 DO
 FOR j:=0 TO aantal_hoeken-1 DO
  Circle(screen_size_x/2+VAL(INTEGER, VAL(REAL,(straal_binnencirkel+i*afstand_leds))*cos(hoek_stap* VAL(REAL,j))), screen_size_y/2+VAL(INTEGER, VAL(REAL,(straal_binnencirkel+i*afstand_leds))*sin(hoek_stap* VAL(REAL,j))),straal_led, _clrRED);
 END;
END;


(* rechthoek rond scherm *)
Rectangle(0,0,screen_size_x-1,screen_size_y -1,_clrGREEN,FALSE);

(*BUTTONS*)
Rectangle(screen_size_x-35,1, screen_size_x, 35,_clrRED,TRUE);
RawOutText(screen_size_x-27, 10, _clrRED,' X ');

Rectangle(35,5,25+BUTTON_SIZE_X, 5+BUTTON_SIZE_Y,_clrGREEN,FALSE);
RawOutText(38,8,_clrWHITE,' CREATE  IM.TXT ');

Rectangle(35,25+BUTTON_SIZE_Y,25+BUTTON_SIZE_X, 25+2*BUTTON_SIZE_Y,_clrGREEN,FALSE);
RawOutText(38,28+BUTTON_SIZE_Y,_clrWHITE,' SEE RESULT ');

(*INTENDSITEIT BUTTONS*)
FOR i:=0 TO 4 DO
 Rectangle(INTENS_KNOPPEN_X+i*AFST_INTENS_KNOPPEN,5,INTENS_KNOPPEN_X+i*AFST_INTENS_KNOPPEN+GROOTTE_INTENS_KNOPPEN, 5+GROOTTE_INTENS_KNOPPEN,_clrGREEN,FALSE);
END;
RawOutText(INTENS_KNOPPEN_X-100,10,_clrWHITE,'INTENSITY:');
RawOutText(INTENS_KNOPPEN_X+0*AFST_INTENS_KNOPPEN+10,10,_clrWHITE,'0');
RawOutText(INTENS_KNOPPEN_X+1*AFST_INTENS_KNOPPEN+10,10,_clrWHITE,'1');
RawOutText(INTENS_KNOPPEN_X+2*AFST_INTENS_KNOPPEN+10,10,_clrWHITE,'2');
RawOutText(INTENS_KNOPPEN_X+3*AFST_INTENS_KNOPPEN+10,10,_clrWHITE,'3');
RawOutText(INTENS_KNOPPEN_X+4*AFST_INTENS_KNOPPEN+10,10,_clrWHITE,'4');


(* ----- HOOFDLUS-------*)
REPEAT

IF Clicked() = TRUE THEN

   mouse_x := VAL(INTEGER,GetMuisX()); (*coordinaten waar geklikt ophalen*)
   mouse_y := VAL(INTEGER,GetMuisY());

   IF (mouse_x>screen_size_x-35) AND (mouse_x<screen_size_x) AND (mouse_y>1) AND (mouse_y<35) THEN (* X *)
      end:=TRUE;
      create_bitmap:=FALSE;
   ELSIF (mouse_x>35) AND (mouse_x<25+BUTTON_SIZE_X) AND (mouse_y>5) AND (mouse_y<5+BUTTON_SIZE_Y) THEN  (* CREATE BITMAP *)
      end:=TRUE;
      create_bitmap:=TRUE;
   ELSIF (mouse_x>35) AND (mouse_x<25+BUTTON_SIZE_X) AND (mouse_y>25+BUTTON_SIZE_Y) AND (mouse_y<25+2*BUTTON_SIZE_Y) THEN  (* SEE RESULT *)

      (* bekijken = leds bekijken zonder cirkels van niet-brandende leds *)
      IF bekijken=TRUE THEN
       bekijken:=FALSE;
      ELSE
       bekijken:=TRUE;
      END;

      IF bekijken = FALSE THEN
       FOR i:=0 TO 23 DO
        FOR j:=0 TO aantal_hoeken-1 DO
         IF led[j+1,i+1].toestand = 0 THEN
          Circle(screen_size_x/2+VAL(INTEGER, VAL(REAL,(straal_binnencirkel+i*afstand_leds))*cos(hoek_stap* VAL(REAL,j))), screen_size_y/2+VAL(INTEGER, VAL(REAL,(straal_binnencirkel+i*afstand_leds))*sin(hoek_stap* VAL(REAL,j))),straal_led, _clrRED);
         END;
        END;
       END;
       bekijken:=FALSE;
      ELSE
       Disc(screen_size_x/2,screen_size_y/2,straal_binnencirkel+23*afstand_leds+straal_led*2, _clrBLACK);
       FOR i:=0 TO 23 DO
        FOR j:=0 TO aantal_hoeken-1 DO
         IF led[j+1,i+1].toestand # 0 THEN
          Disc(screen_size_x/2+VAL(INTEGER, VAL(REAL,(straal_binnencirkel+i*afstand_leds))*cos(hoek_stap* VAL(REAL,j))), screen_size_y/2+VAL(INTEGER, VAL(REAL,(straal_binnencirkel+i*afstand_leds))*sin(hoek_stap* VAL(REAL,j))),straal_led, Kleur(led[j+1,i+1].toestand));
         END;
        END;
       END;
      END;

   ELSIF (mouse_x>INTENS_KNOPPEN_X) AND (mouse_x<INTENS_KNOPPEN_X+GROOTTE_INTENS_KNOPPEN) AND (mouse_y>5) AND (mouse_y<5+GROOTTE_INTENS_KNOPPEN) THEN  (* INTENS 0 *)
      intens0:=TRUE;
      intens1:=FALSE;
      intens2:=FALSE;
      intens3:=FALSE;
      intens4:=FALSE;
   ELSIF (mouse_x>INTENS_KNOPPEN_X+1*AFST_INTENS_KNOPPEN) AND (mouse_x<INTENS_KNOPPEN_X+1*AFST_INTENS_KNOPPEN+GROOTTE_INTENS_KNOPPEN) AND (mouse_y>5) AND (mouse_y<5+GROOTTE_INTENS_KNOPPEN) THEN  (* INTENS 1 *)
      intens0:=FALSE;
      intens1:=TRUE;
      intens2:=FALSE;
      intens3:=FALSE;
      intens4:=FALSE;
   ELSIF (mouse_x>INTENS_KNOPPEN_X+2*AFST_INTENS_KNOPPEN) AND (mouse_x<INTENS_KNOPPEN_X+2*AFST_INTENS_KNOPPEN+GROOTTE_INTENS_KNOPPEN) AND (mouse_y>5) AND (mouse_y<5+GROOTTE_INTENS_KNOPPEN) THEN  (* INTENS 2 *)
      intens0:=FALSE;
      intens1:=FALSE;
      intens2:=TRUE;
      intens3:=FALSE;
      intens4:=FALSE;
   ELSIF (mouse_x>INTENS_KNOPPEN_X+3*AFST_INTENS_KNOPPEN) AND (mouse_x<INTENS_KNOPPEN_X+3*AFST_INTENS_KNOPPEN+GROOTTE_INTENS_KNOPPEN) AND (mouse_y>5) AND (mouse_y<5+GROOTTE_INTENS_KNOPPEN) THEN  (* INTENS 3 *)
      intens0:=FALSE;
      intens1:=FALSE;
      intens2:=FALSE;
      intens3:=TRUE;
      intens4:=FALSE;
   ELSIF (mouse_x>INTENS_KNOPPEN_X+4*AFST_INTENS_KNOPPEN) AND (mouse_x<INTENS_KNOPPEN_X+4*AFST_INTENS_KNOPPEN+GROOTTE_INTENS_KNOPPEN) AND (mouse_y>5) AND (mouse_y<5+GROOTTE_INTENS_KNOPPEN) THEN  (* INTENS 4 *)
      intens0:=FALSE;
      intens1:=FALSE;
      intens2:=FALSE;
      intens3:=FALSE;
      intens4:=TRUE;
   END;

   (* klikken op leds *)
   FOR i:=0 TO 23 DO
    FOR j:=0 TO aantal_hoeken-1 DO
     (* middelpunt led kortere naam geven *)
     mp_x := screen_size_x/2+VAL(INTEGER, VAL(REAL,(straal_binnencirkel+i*afstand_leds))*cos(hoek_stap* VAL(REAL,j)));
     mp_y := screen_size_y/2+VAL(INTEGER, VAL(REAL,(straal_binnencirkel+i*afstand_leds))*sin(hoek_stap* VAL(REAL,j)));
     rho  := straal_led;

     IF (mouse_x > mp_x - rho) AND (mouse_x < mp_x + rho) AND (mouse_y > mp_y - rho) AND (mouse_y < mp_y + rho) THEN

	IF    intens0  = TRUE THEN
	 led[j+1,i+1].toestand:=0;
	 Disc(screen_size_x/2+VAL(INTEGER, VAL(REAL,(straal_binnencirkel+i*afstand_leds))*cos(hoek_stap* VAL(REAL,j))), screen_size_y/2+VAL(INTEGER, VAL(REAL,(straal_binnencirkel+i*afstand_leds))*sin(hoek_stap* VAL(REAL,j))),straal_led, _clrBLACK);
         Circle(screen_size_x/2+VAL(INTEGER, VAL(REAL,(straal_binnencirkel+i*afstand_leds))*cos(hoek_stap* VAL(REAL,j))), screen_size_y/2+VAL(INTEGER, VAL(REAL,(straal_binnencirkel+i*afstand_leds))*sin(hoek_stap* VAL(REAL,j))),straal_led, _clrRED);
        ELSIF intens1  = TRUE THEN
	 led[j+1,i+1].toestand:=1;
         Disc(screen_size_x/2+VAL(INTEGER, VAL(REAL,(straal_binnencirkel+i*afstand_leds))*cos(hoek_stap* VAL(REAL,j))), screen_size_y/2+VAL(INTEGER, VAL(REAL,(straal_binnencirkel+i*afstand_leds))*sin(hoek_stap* VAL(REAL,j))),straal_led, _clrWHITE);
        ELSIF intens2 = TRUE THEN
	 led[j+1,i+1].toestand:=2;
         Disc(screen_size_x/2+VAL(INTEGER, VAL(REAL,(straal_binnencirkel+i*afstand_leds))*cos(hoek_stap* VAL(REAL,j))), screen_size_y/2+VAL(INTEGER, VAL(REAL,(straal_binnencirkel+i*afstand_leds))*sin(hoek_stap* VAL(REAL,j))),straal_led, _clrGRAY);
        ELSIF intens3 = TRUE THEN
	 led[j+1,i+1].toestand:=3;
	 Disc(screen_size_x/2+VAL(INTEGER, VAL(REAL,(straal_binnencirkel+i*afstand_leds))*cos(hoek_stap* VAL(REAL,j))), screen_size_y/2+VAL(INTEGER, VAL(REAL,(straal_binnencirkel+i*afstand_leds))*sin(hoek_stap* VAL(REAL,j))),straal_led, _clrLIGHTYELLOW);
        ELSIF intens4 = TRUE THEN
	 led[j+1,i+1].toestand:=4;
	 Disc(screen_size_x/2+VAL(INTEGER, VAL(REAL,(straal_binnencirkel+i*afstand_leds))*cos(hoek_stap* VAL(REAL,j))), screen_size_y/2+VAL(INTEGER, VAL(REAL,(straal_binnencirkel+i*afstand_leds))*sin(hoek_stap* VAL(REAL,j))),straal_led, _clrRED);
        END;
	
     END;
    END;
   END;

END;

UNTIL end=TRUE;
(* EINDE HOOFDLUS *)

(* aanmaken van textdocument *)
IF create_bitmap=TRUE THEN

  BeeldMatrix();

  MaakText();

END;




END Beeldprogrammer_verschill_intensit.



