IMPLEMENTATION MODULE Mouse;
 <* M2EXTENSIONS + *>  <* GUI + *>
IMPORT Windows;
FROM IO IMPORT WrStr,WrLn;
FROM SYSTEM IMPORT ADR;
FROM Graph IMPORT Init;
CONST
	szAppName = "M";
VAR x,y  : INTEGER;
		msg  : Windows.MSG;
		hwnd : Windows.HWND;
		wc   : Windows.WNDCLASSEX;
		bMoved,bClicked: BOOLEAN;
		knoppen: Knoppen;

PROCEDURE [Windows.CALLBACK] WndProc (hwnd : Windows.HWND;iMsg : Windows.UINT; wParam : Windows.WPARAM; lParam : Windows.LPARAM) : Windows.LRESULT;
VAR p : Windows.POINTS;
BEGIN
  CASE (iMsg) OF
    | Windows.WM_DESTROY     :
			Windows.PostQuitMessage (0);
      RETURN 0;
		| Windows.WM_MOUSEMOVE   :
			p := Windows.MAKEPOINTS(lParam);
			x := p.x;
			y := p.y;
			bMoved := TRUE;
		  RETURN 0;
		| Windows.WM_LBUTTONUP :
			knoppen[1] := TRUE;
			bClicked    := TRUE;
			RETURN 0;
		| Windows.WM_MBUTTONUP :
			knoppen[2] := TRUE;
			bClicked    := TRUE;
			RETURN 0;
		| Windows.WM_RBUTTONUP :
			knoppen[3] := TRUE;
			bClicked    := TRUE;
			RETURN 0;


	ELSE
  RETURN Windows.DefWindowProc (hwnd, iMsg, wParam, lParam);
	END;
END WndProc;

PROCEDURE InitApplication(): BOOLEAN;
BEGIN
  wc.cbSize        := SIZE(wc);
  wc.style         := Windows.CS_SET{};
  wc.lpfnWndProc   := WndProc;
  wc.cbClsExtra    := 0;
  wc.cbWndExtra    := 0;
  wc.hInstance     := Windows.MyInstance();
  wc.hIcon         := Windows.LoadIcon (NIL, Windows.IDI_APPLICATION);
  wc.hCursor       := Windows.LoadCursor (NIL, Windows.IDC_ARROW);
  wc.hbrBackground := Windows.CreateSolidBrush(000h);
  wc.lpszMenuName  := NIL;
  wc.lpszClassName := ADR(szAppName);
  wc.hIconSm       := Windows.LoadIcon (NIL,Windows.IDI_APPLICATION);

  RETURN Windows.RegisterClassEx(wc)#0;
END InitApplication;

PROCEDURE InitMainWindow(x,y,w,h:CARDINAL) : BOOLEAN;
BEGIN
	IF (Init(x,y,w,h)) THEN
  hwnd := Windows.CreateWindow (szAppName,"",Windows.WS_CHILD,0,0,w,h,Windows.FindWindow("GraphWnd",NIL),NIL,Windows.MyInstance(),NIL);
  Windows.ShowWindow(hwnd, Windows.SW_SHOWDEFAULT);
  Windows.UpdateWindow(hwnd);
  RETURN TRUE;
	END;
	RETURN FALSE;
END InitMainWindow;

PROCEDURE InitMuis(x,y,w,h:INTEGER):BOOLEAN;
BEGIN
	RETURN (InitApplication()  AND  InitMainWindow(x,y,w,h));
END InitMuis;

PROCEDURE UpdateMuis();
BEGIN
	bMoved   := FALSE;
	bClicked := FALSE;
	knoppen[1] := FALSE;
	knoppen[2] := FALSE;
	knoppen[3] := FALSE;
	WHILE (Windows.PeekMessage(msg,NIL,Windows.WM_MOUSEFIRST,Windows.WM_MOUSELAST,Windows.PM_REMOVE)) DO
		Windows.TranslateMessage(msg);
		Windows.DispatchMessage(msg);
	END;
END UpdateMuis;
PROCEDURE Clicked():BOOLEAN;
BEGIN
	UpdateMuis();
	RETURN bClicked;
END Clicked;
PROCEDURE Moved():BOOLEAN;
BEGIN
	UpdateMuis();
	RETURN bMoved;
END Moved;
PROCEDURE GetMuisX():INTEGER;
BEGIN
  RETURN x;
END GetMuisX;

PROCEDURE GetMuisY():INTEGER;
BEGIN
  RETURN y;
END GetMuisY;
PROCEDURE GetKnoppen():Knoppen;
BEGIN
	RETURN knoppen;
END GetKnoppen;
END Mouse.
